 --desc: gets the backup history, defaulting to FULL backup only, for current db in scope
SELECT TOP 100
@@SERVERNAME As ServerName,
s.database_name,
s.backup_set_uuid,
  ElapsedTime = dt.Days + ':' + dt.Hours + ':' + dt.Minutes + ':' + dt.Seconds,
m.physical_device_name,
CAST(CAST(s.backup_size / 1000000 AS INT) AS VARCHAR(14)) + ' ' + 'MB' AS bkSize,
CAST(DATEDIFF(second, s.backup_start_date,
s.backup_finish_date) AS VARCHAR(30)) + ' ' + 'Seconds' TimeTaken,
s.backup_start_date,
s.backup_finish_date,
CAST(s.first_lsn AS VARCHAR(50)) AS first_lsn,
CAST(s.last_lsn AS VARCHAR(50)) AS last_lsn,
CASE s.[type] WHEN 'D' THEN 'Full'
WHEN 'I' THEN 'Differential'
WHEN 'L' THEN 'Transaction Log'
END AS BackupType,
s.server_name,
s.recovery_model
FROM msdb.dbo.backupset s
INNER JOIN msdb.dbo.backupmediafamily m ON s.media_set_id = m.media_set_id
    CROSS APPLY(SELECT [Days]          = RIGHT('000' + CONVERT(VARCHAR(128),datepart(day,   s.backup_finish_date - s.backup_start_date)-1),2),
                       [Hours]         = RIGHT('000' + CONVERT(VARCHAR(128),DATEPART(Hour,  s.backup_finish_date - s.backup_start_date)),2),
                       [Minutes]       = RIGHT('000' + CONVERT(VARCHAR(128),datepart(Minute,s.backup_finish_date - s.backup_start_date)),2),
                       [Seconds]       = RIGHT('000' + CONVERT(VARCHAR(128),datepart(Second,s.backup_finish_date - s.backup_start_date)),2)
               ) dt
WHERE 1=1
AND s.[type] IN('D','I','L')
AND s.database_name = CASE WHEN DB_NAME() = 'master' THEN  s.database_name ELSE DB_NAME() END -- Remove this line for all the database
ORDER BY backup_start_date DESC, backup_finish_date
GO