--desc: Get locks in the databases
DECLARE @SpidToWatch INT = 0
DECLARE @LimitToTablelocks INT = 1
IF OBJECT_ID('tempdb..[#AllLocks]') IS NOT NULL 
DROP TABLE [#AllLocks] 

DECLARE @dbid int
SELECT @dbid = DB_ID('NDD_ADP_RAW')

CREATE TABLE #AllLocks(spid int,dbid int,ObjId INT,IndId INT,Type VARCHAR(128),Resource VARCHAR(128),Mode VARCHAR(128),Status VARCHAR(128))
INSERT INTO #AllLocks
EXECUTE [sys].[sp_lock]
SELECT DISTINCT 'KILL ' + CONVERT(VARCHAR,[lckz].[spid]) + ';' AS KillCommand,
DB_NAME([lckz].[dbid]) AS DatabaseName,
OBJECT_SCHEMA_NAME([lckz].[ObjId],[lckz].[dbid]) +'.' + OBJECT_NAME([lckz].[ObjId],[lckz].[dbid]) AS QualifiedObjectName,
[lckz].[spid],
[sess].[login_name],
[sess].[host_name]  AS [host_name],
[sess].[program_name] AS [program_name],
 ElapsedTime = dt.days + ':' + dt.Hours + ':' + dt.Minutes + ':' + dt.Seconds,
sess.[last_request_start_time],
[lckz].[IndId],
[lckz].[Type],
[lckz].[Resource],
[lckz].[Mode],
[lckz].[Status] FROM #AllLocks lckz
INNER JOIN sys.dm_exec_sessions sess
ON [lckz].[spid] = [sess].[session_id]
    CROSS APPLY(SELECT [Days]          = RIGHT('000' + CONVERT(VARCHAR(128),datepart(day,GETDATE() - sess.[last_request_start_time])-1),2),
                       [Hours]         = RIGHT('000' + CONVERT(VARCHAR(128),DATEPART(Hour,GETDATE() - sess.[last_request_start_time])),2),
                       [Minutes]       = RIGHT('000' + CONVERT(VARCHAR(128),datepart(Minute,GETDATE() - sess.[last_request_start_time])),2),
                       [Seconds]       = RIGHT('000' +CONVERT(VARCHAR(128),datepart(Second,GETDATE() - sess.[last_request_start_time])),2)
               ) dt

WHERE 1=1
AND ([lckz].[spid] = @SpidToWatch OR @SpidToWatch=0)
--AND dbid=@dbid
AND [lckz].[Mode] LIKE '%x%'
AND  [lckz].[Type] =  CASE WHEN @LimitToTablelocks  = 1 THEN  'TAB' ELSE  [lckz].[Type] END
ORDER BY [lckz].[spid]