--desc: dbcc opentran on all databases, with a nice cross apply of info
SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;
IF OBJECT_ID('tempdb..[#DBCCResults]') IS NOT NULL 
DROP TABLE [#DBCCResults] 
GO
CREATE TABLE [#DBCCResults] ( 
[ResultsID]     INT              IDENTITY(1,1)          NOT NULL,
[DatabaseName]  VARCHAR(128)                                NULL,
[ObjectInfo]    VARCHAR(128)                                NULL,
[ResultsText]   VARCHAR(max)                                NULL,
[DWCreateDate]  DATETIME                                    NULL DEFAULT (getdate()))


declare
  @isql varchar(2000),
  @val varchar(64)
  
  declare c1 cursor LOCAL FORWARD_ONLY STATIC READ_ONLY for
  --###############################################################################################
  --cursor definition
  --###############################################################################################
   select name 
   FROM master.sys.databases 
   WHERE state_desc = 'ONLINE'
   AND replica_id IS NULL
  --###############################################################################################
  open c1
  fetch next from c1 into @val
  While @@fetch_status <> -1
    begin
    select @isql = '
INSERT INTO #DBCCResults([ObjectInfo],[ResultsText])
 execute(''DBCC OPENTRAN (''''@val'''') WITH TABLERESULTS'');
UPDATE #DBCCResults SET DatabaseName = ''@val'' WHERE DatabaseName IS NULL;'
    select @isql = replace(@isql,'@val',@val)
    print @isql
    exec(@isql)

    fetch next from c1 into @val
    end
  close c1
  deallocate c1
SELECT 
CONVERT(VARCHAR(128),@@SERVERNAME) AS ServerName,
[ElapsedTime dd:hh:mm:ss] = MAX(dt.Days) + ':' + MAX(dt.Hours) + ':' + MAX(dt.Minutes) + ':' + MAX(dt.Seconds),
DatabaseName,
DWCreateDate,
MAX(CASE WHEN ObjectInfo = 'OLDACT_SID' THEN ResultsText ELSE '' END) AS OLDACT_SID,
MAX(CASE WHEN ObjectInfo = 'OLDACT_STARTTIME' THEN ResultsText ELSE '' END) AS OLDACT_STARTTIME,
MAX(CASE WHEN ObjectInfo = 'OLDACT_LSN' THEN ResultsText ELSE '' END) AS OLDACT_LSN,
MAX(CASE WHEN ObjectInfo = 'OLDACT_RECOVERYUNITID' THEN ResultsText ELSE '' END) AS OLDACT_RECOVERYUNITID,
MAX(CASE WHEN ObjectInfo = 'OLDACT_NAME' THEN ResultsText ELSE '' END) AS OLDACT_NAME,
MAX(CASE WHEN ObjectInfo = 'OLDACT_UID' THEN ResultsText ELSE '' END) AS OLDACT_UID,
MAX(CASE WHEN ObjectInfo = 'OLDACT_SPID' THEN ResultsText ELSE '' END) AS OLDACT_SPID
FROM #DBCCResults
OUTER APPLY(SELECT CONVERT(DATETIME,ResultsText) AS TransactionStartTime WHERE ObjectInfo ='OLDACT_STARTTIME') fn
    CROSS APPLY(SELECT [Days]          = RIGHT('000' + CONVERT(VARCHAR(128),datepart(day,GETDATE() - fn.TransactionStartTime)-1),2),
                       [Hours]         = RIGHT('000' + CONVERT(VARCHAR(128),DATEPART(Hour,GETDATE() - fn.TransactionStartTime)),2),
                       [Minutes]       = RIGHT('000' + CONVERT(VARCHAR(128),datepart(Minute,GETDATE() - fn.TransactionStartTime)),2),
                       [Seconds]       = RIGHT('000' +CONVERT(VARCHAR(128),datepart(Second,GETDATE() - fn.TransactionStartTime)),2)
               ) dt
GROUP BY DatabaseName,DWCreateDate

SELECT     [ElapsedTime dd:hh:mm:ss] = dt.Days + ':' + dt.Hours + ':' + dt.Minutes + ':' + dt.Seconds,
TheText.[text],
db.* FROM #DBCCResults db
OUTER APPLY(SELECT CASE WHEN ISNUMERIC(ResultsText) = 1 THEN CONVERT(INT,ResultsText) ELSE -1 END AS TransactionSpid WHERE ObjectInfo ='OLDACT_SPID') fnspid
OUTER APPLY ( SELECT 
                prsz.[spid], fntx.text
              FROM sys.sysprocesses prsz
              CROSS APPLY sys.dm_exec_sql_text(prsz.sql_handle) fntx
              WHERE prsz.[spid] = fnspid.TransactionSpid ) TheText
--ON TheText.spid = 
OUTER APPLY(SELECT CONVERT(DATETIME,ResultsText) AS TransactionStartTime WHERE ObjectInfo ='OLDACT_STARTTIME') fn
    CROSS APPLY(SELECT [Days]          = RIGHT('000' + CONVERT(VARCHAR(128),datepart(day,GETDATE() - fn.TransactionStartTime)-1),2),
                       [Hours]         = RIGHT('000' + CONVERT(VARCHAR(128),DATEPART(Hour,GETDATE() - fn.TransactionStartTime)),2),
                       [Minutes]       = RIGHT('000' + CONVERT(VARCHAR(128),datepart(Minute,GETDATE() - fn.TransactionStartTime)),2),
                       [Seconds]       = RIGHT('000' +CONVERT(VARCHAR(128),datepart(Second,GETDATE() - fn.TransactionStartTime)),2)
               ) dt
GO