--desc: checks all databases for compression info
IF OBJECT_ID('tempdb..[#CompressionOverview]') IS NOT NULL 
DROP TABLE [#CompressionOverview] 
CREATE TABLE [#CompressionOverview] ( 
[DatabaseName]                VARCHAR(128)                                NULL,
[MSIndexCount]                INT                                         NULL,
[NoneCompressionIndexCount]   INT                                         NULL,
[RowCompressionIndexCount]    INT                                         NULL,
[PageCompressionIndexCount]   INT                                         NULL,
[OtherCompressionIndexCount]  INT                                         NULL,
[UserIndexCount]              INT                                         NULL,
[TotalCount]                  INT                                         NULL)

EXECUTE [sys].[sp_MSforeachdb] @command1 = '
IF db_id(''?'') > 4
INSERT INTO [#CompressionOverview]([DatabaseName],[MSIndexCount],[NoneCompressionIndexCount],[RowCompressionIndexCount],[PageCompressionIndexCount],[OtherCompressionIndexCount],[UserIndexCount],[TotalCount])
SELECT 
  ''?'' AS DatabaseName,
  ISNULL(SUM(CASE WHEN  o.is_ms_shipped = 1 THEN 1 ELSE 0 END),0) AS MSIndexCount,
  ISNULL(SUM(CASE WHEN  o.is_ms_shipped = 0 AND [data_compression_desc] =''NONE'' THEN 1 ELSE 0 END ),0)                AS NoneCompressionIndexCount,
  ISNULL(SUM(CASE WHEN  o.is_ms_shipped = 0 AND [data_compression_desc] =''ROW'' THEN 1 ELSE 0 END ),0)                AS RowCompressionIndexCount,
  ISNULL(SUM(CASE WHEN  o.is_ms_shipped = 0 AND [data_compression_desc] = ''PAGE''THEN 1 ELSE 0 END ),0)               AS PageCompressionIndexCount,
  ISNULL(SUM(CASE WHEN  o.is_ms_shipped = 0 AND [data_compression_desc] NOT IN (''NONE'',''ROW'',''PAGE'') THEN 1 ELSE 0 END),0)  AS OtherCompressionIndexCount,
  ISNULL(SUM(CASE WHEN  o.is_ms_shipped = 0 THEN 1 ELSE 0 END),0) AS UserIndexCount,
  COUNT(*) AS  TotalCount
FROM   [?].sys.indexes AS i
            INNER JOIN [?].sys.objects AS o
                    ON i.object_id = o.object_id
            INNER JOIN [?].sys.[partitions] AS ps
                    ON i.object_id = ps.object_id
                       AND i.index_id = ps.index_id 
WHERE o.schema_id <> 4
--group by [data_compression_desc] '

SELECT [DatabaseName],
       [MSIndexCount],
       [NoneCompressionIndexCount],
       --[RowCompressionIndexCount],
       [PageCompressionIndexCount],
       --[OtherCompressionIndexCount],
       [UserIndexCount],
       [TotalCount] FROM [#CompressionOverview] ORDER BY [DatabaseName]