--desc: slowest stored procedures
  DECLARE @ServerRestartedDate varchar(30);
  DECLARE @objectname varchar(128) = '';
  SELECT @ServerRestartedDate = CONVERT(varchar(30),dbz.create_date,120)  from sys.databases dbz where name='tempdb';
;WITH MyCTE
AS
(


--DECLARE @seconds INT = 15
     SELECT 
      @ServerRestartedDate As ServerRestartedDate,
      st.[cached_time] AS LastCached,
           st.last_execution_time As LastExecutionTime,
           CONVERT(DECIMAL(9,3),(st.total_worker_time/ 1000000.0) / NULLIF(st.execution_count,0)) AS AverageSeconds,
           FORMAT(st.execution_count,'###,###,###,###,###') As TotalExecutions,
           (st.last_elapsed_time / 1000000.0 ) As LastElapsedSeconds,
             (st.max_elapsed_time / 1000000.0 ) As MaxElapsedSeconds,
			 '--LastExecutionTime: [' + CONVERT(VARCHAR(30),st.last_execution_time) 
			 + ']; AverageSeconds: [' + FORMAT(CONVERT(DECIMAL(9,3),(st.total_worker_time/ 1000000.0)),'###,###,###,###,###.00') 
			 + ']; TotalExecutions [' + FORMAT(st.execution_count,'###,###,###,###,###')
			 + ']; LastElapsedSeconds [' + CONVERT(VARCHAR(30),(st.last_elapsed_time / 1000000.0 ))
			 + ']; MaxElapsedSeconds [' + CONVERT(VARCHAR(30),(st.max_elapsed_time / 1000000 )) + '];'
			 As notes,
             Db_name(fn.dbid) AS dbname,
             'execute sp_recompile ''' + OBJECT_SCHEMA_NAME(fn.objectid, fn.dbid) +'.' + Object_name(fn.objectid, fn.dbid) + ''';' AS recomple,
             OBJECT_SCHEMA_NAME(fn.objectid, fn.dbid) +'.' + Object_name(fn.objectid, fn.dbid) AS QualifiedObjectName,
             Object_schema_name(fn.objectid, fn.dbid) AS schemaname,
             Object_name(fn.objectid, fn.dbid) AS objectname,
             pl.[query_plan],
             fn.*,
             [st].[database_id],
             [st].[object_id],
             [st].[type],
             [st].[type_desc],
             [st].[sql_handle],
             [st].[plan_handle],
             [st].[cached_time],
             [st].[last_execution_time],
			FORMAT([st].[execution_count],'###,###,###,###,##0') AS [execution_count],
			FORMAT([st].[total_worker_time],'###,###,###,###,##0') AS [total_worker_time],
			FORMAT([st].[last_worker_time],'###,###,###,###,##0') AS [last_worker_time],
			FORMAT([st].[min_worker_time],'###,###,###,###,##0') AS [min_worker_time],
			FORMAT([st].[max_worker_time],'###,###,###,###,##0') AS [max_worker_time],
			FORMAT([st].[total_physical_reads],'###,###,###,###,###') AS [total_physical_reads],
			FORMAT([st].[last_physical_reads],'###,###,###,###,##0') AS [last_physical_reads],
			FORMAT([st].[min_physical_reads],'###,###,###,###,##0') AS [min_physical_reads],
			FORMAT([st].[max_physical_reads],'###,###,###,###,##0') AS [max_physical_reads],
			FORMAT([st].[total_logical_writes],'###,###,###,###,##0') AS [total_logical_writes],
			FORMAT([st].[last_logical_writes],'###,###,###,###,##0') AS [last_logical_writes],
			FORMAT([st].[min_logical_writes],'###,###,###,###,##0') AS [min_logical_writes],
			FORMAT([st].[max_logical_writes],'###,###,###,###,##0') AS [max_logical_writes],
			FORMAT([st].[total_logical_reads],'###,###,###,###,##0') AS [total_logical_reads],
			FORMAT([st].[last_logical_reads],'###,###,###,###,##0') AS [last_logical_reads],
			FORMAT([st].[min_logical_reads],'###,###,###,###,##0') AS [min_logical_reads],
			FORMAT([st].[max_logical_reads],'###,###,###,###,##0') AS [max_logical_reads],
			FORMAT([st].[total_elapsed_time],'###,###,###,###,##0') AS [total_elapsed_time],
			FORMAT([st].[last_elapsed_time],'###,###,###,###,##0') AS [last_elapsed_time],
			FORMAT([st].[min_elapsed_time],'###,###,###,###,##0') AS [min_elapsed_time],
			FORMAT([st].[max_elapsed_time],'###,###,###,###,##0') AS [max_elapsed_time],
			FORMAT([st].[total_spills],'###,###,###,###,##0') AS [total_spills],
			FORMAT([st].[last_spills],'###,###,###,###,##0') AS [last_spills],
			FORMAT([st].[min_spills],'###,###,###,###,##0') AS [min_spills],
			FORMAT([st].[max_spills],'###,###,###,###,##0') AS [max_spills],
			FORMAT([st].[total_num_physical_reads],'###,###,###,###,##0') AS [total_num_physical_reads],
			FORMAT([st].[last_num_physical_reads],'###,###,###,###,##0') AS [last_num_physical_reads],
			FORMAT([st].[min_num_physical_reads],'###,###,###,###,##0') AS [min_num_physical_reads],
			FORMAT([st].[max_num_physical_reads],'###,###,###,###,##0') AS [max_num_physical_reads],
			FORMAT([st].[total_page_server_reads],'###,###,###,###,##0') AS [total_page_server_reads],
			FORMAT([st].[last_page_server_reads],'###,###,###,###,##0') AS [last_page_server_reads],
			FORMAT([st].[min_page_server_reads],'###,###,###,###,##0') AS [min_page_server_reads],
			FORMAT([st].[max_page_server_reads],'###,###,###,###,##0') AS [max_page_server_reads],
			FORMAT([st].[total_num_page_server_reads],'###,###,###,###,##0') AS [total_num_page_server_reads],
			FORMAT([st].[last_num_page_server_reads],'###,###,###,###,##0') AS [last_num_page_server_reads],
			FORMAT([st].[min_num_page_server_reads],'###,###,###,###,##0') AS [min_num_page_server_reads],
			FORMAT([st].[max_num_page_server_reads],'###,###,###,###,##0') AS [max_num_page_server_reads] 
      FROM   sys.[dm_exec_procedure_stats] st
             CROSS APPLY sys.dm_exec_sql_text(st.[sql_handle]) fn
             CROSS APPLY sys.dm_exec_query_plan(st.[plan_handle]) pl
      WHERE 1=1
      --AND st.last_elapsed_time >= ( 1000000  * 5 ) --15 seconds default
      AND (Db_name(fn.dbid)  = DB_NAME() OR DB_NAME() = 'master')
     -- ORDER BY st.execution_count DESC
      )

      SELECT TOP 100 * FROM MyCTE 
      WHERE NULLIF(@objectname,'') IS NULL OR  @objectname = objectname
      ORDER BY [MyCTE].[AverageSeconds] desc