--desc: adhoc commands performance
  DECLARE @ServerRestartedDate varchar(30);
  DECLARE @objectname varchar(128) = '';
  SELECT @ServerRestartedDate = CONVERT(varchar(30),dbz.create_date,120)  from sys.databases dbz where name='tempdb';
;WITH MyCTE
AS
(


--DECLARE @seconds INT = 15
     SELECT 
      @ServerRestartedDate As ServerRestartedDate,
           st.last_execution_time As LastExecutionTime,
		   db_name(pl.dbid) AS DatabaseName,
           CONVERT(DECIMAL(9,3),(st.total_worker_time/ 1000000.0) / NULLIF(st.execution_count,0)) AS AverageSeconds,
           st.execution_count As TotalExecutions,
           (st.last_elapsed_time / 1000000.0 ) As LastElapsedSeconds,
           (st.max_elapsed_time / 1000000 ) As MaxElapsedSeconds,
		   [% cpu] = Cast(st.total_worker_time * 100.0 / st.total_elapsed_time AS DECIMAL(28, 2)),
           [% waiting] = Cast(( st.total_elapsed_time - st.total_worker_time ) * 100.0 / st.total_elapsed_time AS DECIMAL(28, 2)),
           [cpu time average (s)] = Cast(( st.total_worker_time ) / 1000000.0 / st.execution_count AS DECIMAL(28, 2)),
           [individual query] = Substring (fn.text, ( st.statement_start_offset / 2 ) + 1, ( ( CASE
                                                                                                          WHEN st.statement_end_offset = -1 THEN Len(CONVERT(NVARCHAR(MAX), fn.text)) * 2
                                                                                                          ELSE st.statement_end_offset
                                                                                                        END - st.statement_start_offset ) / 2 ) + 1),

             pl.[query_plan],
             fn.*,
             st.*
      FROM   sys.dm_exec_query_stats st
             CROSS APPLY sys.dm_exec_sql_text(st.[sql_handle]) fn
             CROSS APPLY sys.dm_exec_query_plan(st.[plan_handle]) pl
      WHERE 1=1
	  AND fn.objectid IS null
      --AND st.last_elapsed_time >= ( 1000000  * 5 ) --15 seconds default
      AND (Db_name(pl.dbid)  = DB_NAME() OR DB_NAME() = 'master')
     -- ORDER BY st.execution_count DESC
      )

      SELECT TOP 100 * FROM MyCTE 
      ORDER BY [MyCTE].[AverageSeconds] desc