--#################################################################################################
-- 2025-05-20 08:34:49.972 MachineName:ViscosityLowell; ComputerBiosName:VISCOSITYLOWELL;  
-- ApplicationName: DBA | AppEmailGroup: lowell.izaguirre@viscosityna.com | ServerUptime[dd:hh:mm:ss]: 00:01:25:06
-- Cname: wks-lowell.workgroup,;  LoginName: VISCOSITYLOWELL\lowell Authorization Scheme: SQL viscositylowell
-- Context: ViscosityLowell,; Database:master; Version: [SQL 2022 || 16.0.4165.4] Developer Edition (64-bit)
--#################################################################################################
SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;
GO
--desc: gets job history, and when the GUI times out
DECLARE @Job_name varchar(128) = '';
SELECT TOP 1000
CONVERT(VARCHAR(128),@@SERVERNAME) AS ServerName,
CASE h.[run_status] WHEN 0 THEN 'Failed' WHEN 1 THEN 'Success' WHEN 3 THEN 'Cancelled' WHEN 4 THEN 'InProgress' ELSE 'Retry' END AS JobStatus,
 j.name as 'JobName',
 s.step_id as 'Step',
 s.step_name as 'StepName',
 msdb.dbo.agent_datetime(run_date, run_time) as 'RunDateTime',
 ((run_duration/10000*3600 + (run_duration/100)%100*60 + run_duration%100 + 31 ) / 60) 
         as 'RunDurationMinutes',
h.[instance_id],
h.[message],
SUSER_SNAME(j.[owner_sid]) AS JobOwner,
pr.[name] AS ProxyName
From msdb.dbo.sysjobs j 
INNER JOIN msdb.dbo.sysjobsteps s 
 ON j.job_id = s.job_id
INNER JOIN msdb.dbo.sysjobhistory h 
 ON s.job_id = h.job_id 
 AND s.step_id = h.step_id 
 AND h.step_id <> 0
 LEFT JOIN msdb.dbo.[sysproxies] pr ON s.[proxy_id] = pr.[proxy_id]
where j.enabled = 1   --Only Enabled Jobs
and (j.name = @Job_name OR NULLIF(@Job_name,'') IS NULL )
and msdb.dbo.agent_datetime(run_date, run_time) 
BETWEEN DATEADD(DAY,-1,GETDATE()) and GETDATE()  --Uncomment for date range queries

AND h.[run_status] <> 1
order by JobName, RunDateTime DESC,h.[instance_id] desc