--desc: finds errors in the ssisdb from midnight
--#################################################################################################
-- [#SSISDB]
--#################################################################################################
IF OBJECT_ID('tempdb..[#messages]') IS NOT NULL 
DROP TABLE [#messages] 
GO
IF OBJECT_ID('tempdb..[#SSISDB]') IS NOT NULL 
DROP TABLE [#SSISDB] 
GO
CREATE TABLE [#SSISDB] ( 
[FolderName]   SYSNAME                                               NOT NULL,
[ProjectName]  SYSNAME                                               NOT NULL,
[PackageName]  NVARCHAR(260)                                         NOT NULL,
[folder_id]    BIGINT                                                NOT NULL,
[project_id]   BIGINT                                                NOT NULL,
[package_id]   BIGINT                                                NOT NULL)

INSERT INTO #SSISDB([FolderName],[ProjectName],[PackageName],[folder_id],[project_id],[package_id])
SELECT 
  [fldz].[name] AS [FolderName],
  [prjz].[name] AS [ProjectName],
  [pkz].[name] AS [PackageName],
  [fldz].[folder_id],
  [prjz].[project_id],
  [pkz].[package_id] 
FROM [SSISDB].[catalog].[packages] [pkz]
  INNER JOIN [SSISDB].[catalog].[projects] [prjz] 
    ON [pkz].[project_id] = [prjz].[project_id]
  INNER JOIN [SSISDB].[catalog].[folders] [fldz] 
    ON [fldz].[folder_id] = [prjz].[folder_id]

--#################################################################################################
-- [#messages]
--#################################################################################################


CREATE TABLE [#messages] ( 
[operation_message_id]  BIGINT                                                NOT NULL,
[operation_id]          BIGINT                                                NOT NULL,
[message_time]          DATETIMEOFFSET                                        NOT NULL,
[message_type]          SMALLINT                                              NOT NULL,
[message_source_type]   SMALLINT                                                  NULL,
[message]               NVARCHAR(max)                                             NULL,
[extended_info_id]      BIGINT                                                    NULL,
[event_message_guid]    UNIQUEIDENTIFIER                                          NULL)

INSERT INTO #messages([operation_message_id],[operation_id],[message_time],[message_type],[message_source_type],[message],[extended_info_id])
SELECT [operation_message_id],[operation_id],[message_time],[message_type],[message_source_type],[message],[extended_info_id]

FROM [SSISDB].[internal].[operation_messages] AS [msgz]
WHERE msgz.[message_type] = 120 
  AND msgz.[message_time] BETWEEN CONVERT(DATE,GETDATE()) AND GETDATE()

    SELECT DISTINCT 
    CONVERT(VARCHAR(128),@@ServerName) AS ServerName,
    [exz].[start_time],
	[msgz].[message_time],
	ssisz.[FolderName],ssisz.[ProjectName],ssisz.[PackageName],
    [msgz].[message_type],
	CASE WHEN [msgz].[message] LIKE '%Error:%' THEN SUBSTRING([msgz].[message],1,CHARINDEX(':',[msgz].[message])) ELSE '' END  As CustomMessageType,
	CASE WHEN [msgz].[message] LIKE '%Error:%' THEN SUBSTRING([msgz].[message],CHARINDEX(':',[msgz].[message]),256) ELSE '' END AS CustomMessage,
    [msgz].[message],
    [opz].[status]
    FROM #SSISDB ssisz
    INNER JOIN [SSISDB].[catalog].[executions] [exz] 
      ON  [exz].[folder_name]  = [ssisz].[FolderName]  
      AND [exz].[project_name] = [ssisz].[ProjectName]
      AND [exz].[package_name] = [ssisz].[PackageName]
    INNER JOIN [SSISDB].[catalog].[operations] [opz]
      ON [exz].[process_id] = [opz].[process_id]
    INNER JOIN  #messages AS [msgz]
    ON [opz].[operation_id] = [msgz].[operation_id]  AND [opz].[status] = 4
	WHERE [exz].[start_time] BETWEEN CONVERT(DATE,GETDATE()) AND GETDATE()
    ORDER BY ssisz.[FolderName],ssisz.[ProjectName],ssisz.[PackageName],msgz.[message_time] desc

	