--verify the cname
DECLARE @ServerName       VARCHAR(128)
DECLARE @ApplicationName  VARCHAR(128)
DECLARE @AppEmailGroup    VARCHAR(128)
DECLARE @ServerLayer      VARCHAR(128)
--#################################################################################################
-- Database Specific Contact Groups if they exist
--#################################################################################################
SELECT @ApplicationName = CONVERT(VARCHAR(4000),prpz.value)    FROM sys.[extended_properties] prpz WHERE prpz.Class=0 
AND prpz.name = 'ApplicationName'
SELECT @AppEmailGroup =      CONVERT(VARCHAR(4000),prpz.value) FROM sys.[extended_properties] prpz WHERE prpz.Class=0 
AND prpz.name = 'AppEmailGroup'
SELECT @ServerName = CONVERT(VARCHAR(128),prpz.value)          FROM sys.[extended_properties] prpz WHERE prpz.Class=0 
AND prpz.name = 'Cname'
SELECT @ServerLayer = CONVERT(VARCHAR(128),prpz.value)         FROM sys.[extended_properties] prpz WHERE prpz.Class=0 
AND prpz.name = 'ServerLayer'
--    SELECT @ServerName AS CName,@ServerLayer AS ServerLayer,@ApplicationName AS ApplicationName,@AppEmailGroup  AS AppEmailGroup
--#################################################################################################
-- Server Level Contact Groups if Database Level are Blank
--#################################################################################################
IF @ApplicationName IS NULL
  SELECT @ApplicationName = CONVERT(VARCHAR(4000),prpz.value)  FROM [master].sys.[extended_properties] prpz WHERE prpz.Class=0 
  AND prpz.name = 'ApplicationName'
IF @AppEmailGroup IS NULL
SELECT @AppEmailGroup =      CONVERT(VARCHAR(4000),prpz.value) FROM [master].sys.[extended_properties] prpz WHERE prpz.Class=0 
AND prpz.name = 'AppEmailGroup'
IF @ServerName IS NULL
SELECT @ServerName = CONVERT(VARCHAR(128),prpz.value)          FROM [master].sys.[extended_properties] prpz WHERE prpz.Class=0 
AND prpz.name = 'Cname'
IF @ServerLayer IS NULL
SELECT @ServerLayer = CONVERT(VARCHAR(128),prpz.value)         FROM [master].sys.[extended_properties] prpz WHERE prpz.Class=0 
AND prpz.name = 'ServerLayer'
    SELECT @ServerName = ISNULL(@ServerName,CONVERT(VARCHAR(128),@@SERVERNAME))
  --  SELECT @ServerName AS CName,@ServerLayer AS ServerLayer,@ApplicationName AS ApplicationName,@AppEmailGroup  AS AppEmailGroup
--desc: trace to find failed logins
declare @TraceIDToReview int
declare @path varchar(255)

SET @TraceIDToReview = 1 --this is the trace you want to review!
SELECT @path = path from sys.traces WHERE id = @TraceIDToReview
SELECT @ServerName AS CName,@ServerLayer AS ServerLayer,
  TE.name As EventClassDescrip,
  T.StartTime, --V.subclass_name As EventSubClassDescrip,
T.TextData,
CASE 
  WHEN T.TextData LIKE '%CLIENT:%' 
  THEN SUBSTRING(T.TextData,CHARINDEX('CLIENT:',T.TextData) -1,30)
  ELSE ''
END AS PossibleIP,
--T.BinaryData,
T.DatabaseID,
--T.TransactionID,
--T.LineNumber,
--T.NTUserName,
--T.NTDomainName,
T.HostName,
--T.ClientProcessID,
T.ApplicationName,
T.LoginName,
--T.SPID,
--T.Duration,

--T.EndTime,
--T.Reads,
--T.Writes,
--T.CPU,
--T.Permissions,
--T.Severity,
--T.EventSubClass,
--T.ObjectID,
T.Success,
--T.IndexID,
--T.IntegerData,
T.ServerName,
T.EventClass,
--T.ObjectType,
--T.NestLevel,
T.State,
T.Error,
--T.Mode,
--T.Handle,
--T.ObjectName,
T.DatabaseName,
--T.FileName,
--T.OwnerName,
--T.RoleName,
--T.TargetUserName,
--T.DBUserName,
--T.LoginSid,
--T.TargetLoginName,
--T.TargetLoginSid,
--T.ColumnPermissions,
--T.LinkedServerName,
--T.ProviderName,
--T.MethodName,
--T.RowCounts,
--T.RequestID,
--T.XactSequence,
--T.EventSequence,
--T.BigintData1,
--T.BigintData2,
--T.GUID,
--T.IntegerData2,
--T.ObjectID2,
--T.Type,
--T.OwnerID,
--T.ParentName,
--T.IsSystem,
--T.Offset,
--T.SourceDatabaseID,
--T.SqlHandle,
T.SessionLoginName,
--T.PlanHandle,
T.GroupID
FROM ::fn_trace_gettable(@path, default) T
LEFT OUTER JOIN sys.trace_events TE ON T.EventClass = TE.trace_event_id
           LEFT OUTER JOIN sys.trace_subclass_values V
             ON T.EventClass = V.trace_event_id AND  T.EventSubClass = V.subclass_value
             WHERE 1=1
             AND StartTime >= DATEADD(dd, DATEDIFF(dd,0,getdate()), 0)
             AND TE.name = 'Audit Login Failed'
             AND V.subclass_name = 'Nonpooled'
             --AND LoginName LIKE '%tkcsowner%'
             --AND TextData IS NOT NULL
             ORDER BY StartTime desc